# ADRs: Architecture Decision Records

An ADR is an Architecture Decision Record. ADRs document design choices made in
a project.

This directory contains quick-lint-js' ADRs.

For more information on ADRs, see [Documenting Architecture Decisions by Michael
Nygard][ADR-bible].

## Active ADRs

* [ADR001: Feature testing with have.h](ADR001-Feature-testing-with-have-h.md)
* [ADR002: Programming language](ADR002-Programming-language.md)
* [ADR003: Vendor sources](ADR003-Vendor-sources.md)
* [ADR004: Generated sources](ADR004-Generated-sources.md)
* [ADR005: Incremental lexing](ADR005-Incremental-lexing.md)
* [ADR006: Location tracking](ADR006-Location-tracking.md)
* [ADR008: Exceptions](ADR010-Exceptions.md)

## Rejected ADRs

* [ADR007: Expression stack](ADR007-Expression-stack.md)

[ADR-bible]: https://cognitect.com/blog/2011/11/15/documenting-architecture-decisions
